#include "VolumeLineModel.h"

// VF[_֌W̃G[`FbN֐
// VF[_߂̌ɌĂяoāAG[
// G[bZ[WfăvOIB
static bool check_cg_error(void)
{
	static int	cntCall = 0;

	CGerror		err = cgGetError();

	cntCall++;

	if(err != CG_NO_ERROR) {
		fk_Printf("[%d]CG ERROR: %s", cntCall, cgGetErrorString(err));
		//exit(1);
		return false;
	}
	return true;
}

// RXgN^ł͓ɂ邱ƂȂ
fk_VolumeLineModel::fk_VolumeLineModel(void)
: fk_Model()
{
	cg_context = NULL;
	ref_image = NULL;
	setShape(&dummyShape);

	return;
}

// fXgN^ŁACg 𐧌䂷邽߂̕ϐj
fk_VolumeLineModel::~fk_VolumeLineModel()
{
	cgDestroyProgram(fragment_shader);
	cgDestroyProgram(vertex_shader);
	cgDestroyContext(cg_context);

	return;
}

// Cg ֌W̏֐
void fk_VolumeLineModel::cgInit(void)
{
	// xʑŜ̕`ƂĂȂƃG[ɂȂ̂ŁAĂ
	Fl::check();

	// o[ebNXVF[_gǂ`FbN
	if(cgGLIsProfileSupported(CG_PROFILE_ARBVP1)) {
		vp_profile = CG_PROFILE_ARBVP1;
	} else {
		fk_Printf("arbvp1 not supported");
		//exit(1);
	}
	// tOgVF[_gǂ`FbN
	if(cgGLIsProfileSupported(CG_PROFILE_ARBFP1)) {
		fp_profile = CG_PROFILE_ARBFP1;
	} else {
		fk_Printf("arbfp1 not supported");
		//exit(1);
	}
	// Cg ̃ReLXgn
	cg_context = cgCreateContext();
	check_cg_error();
	// o[ebNXVF[_ǂݍ
	vertex_shader = cgCreateProgramFromFile(cg_context, CG_SOURCE,
			"shader/cg_Volumelines.fx", vp_profile, NULL, NULL);
	check_cg_error();
	// tOgVF[_ǂݍ
	fragment_shader = cgCreateProgramFromFile(cg_context, CG_SOURCE,
			"shader/cg_Volumelines_fragment.fx", fp_profile, NULL, NULL);
	check_cg_error();

	// ǂݍ񂾃VF[_nĂReLXgɓnĂ
	cgGLLoadProgram(vertex_shader);
	check_cg_error();
	cgGLLoadProgram(fragment_shader);
	check_cg_error();

	// VF[_ɓnp[^ƁAVF[_ł̕ϐ̖Oт
	model_view_proj_matrix = cgGetNamedParameter(vertex_shader, "ModelViewProj");
	model_view_matrix = cgGetNamedParameter(vertex_shader, "ModelView");

	param0 = cgGetNamedParameter(vertex_shader, "IN.startpos");
    param1 = cgGetNamedParameter(vertex_shader, "IN.endpos");
    param8 = cgGetNamedParameter(vertex_shader, "IN.param8");
    param9 = cgGetNamedParameter(vertex_shader, "IN.param9");

	f_tex[0] = cgGetNamedParameter(fragment_shader, "texture0");
	f_tex[1] = cgGetNamedParameter(fragment_shader, "texture1");

	return;
}

void fk_VolumeLineModel::draw_line(fk_Vector inFromPos, fk_Vector inToPos, float fVolumeWidth)
{
	//
	// Each volume line is rendered as a quad, so we need to make sure that 
	// GL_QUADS is the currently selected primitive.
	//
	float fFromPos_x = (float)inFromPos.x;
	float fFromPos_y = (float)inFromPos.y;
	float fFromPos_z = (float)inFromPos.z;
	float fToPos_x = (float)inToPos.x;
	float fToPos_y = (float)inToPos.y;
	float fToPos_z = (float)inToPos.z;
	float fHalfVolumeWidth = fVolumeWidth * 0.5f;

    cgGLSetParameter3f(param1, fToPos_x, fToPos_y, fToPos_z);
    cgGLSetParameter4f(param8, fVolumeWidth , fVolumeWidth, 0, 0); // (SZx1, SZx2, TexX, TexY)
    cgGLSetParameter3f(param9, -fVolumeWidth, 0, fHalfVolumeWidth);            // SZy
    cgGLSetParameter3f(param0, fFromPos_x, fFromPos_y, fFromPos_z); // Attrib #0 MUST be called at the END

    cgGLSetParameter3f(param1, fFromPos_x, fFromPos_y, fFromPos_z);
    cgGLSetParameter4f(param8, fVolumeWidth, fVolumeWidth, 0.25f, 0);// (SZx1, SZx2, TexX, TexY)
    cgGLSetParameter3f(param9, fVolumeWidth, 0, fHalfVolumeWidth);               // SZy
    cgGLSetParameter3f(param0, fToPos_x, fToPos_y, fToPos_z);

    cgGLSetParameter3f(param1, fFromPos_x, fFromPos_y, fFromPos_z);
    cgGLSetParameter4f(param8, fVolumeWidth, fVolumeWidth, 0.25f, 0.25f);// (SZx1, SZx2, TexX, TexY)
    cgGLSetParameter3f(param9, -fVolumeWidth, 0, fHalfVolumeWidth);                  // SZy
    cgGLSetParameter3f(param0, fToPos_x, fToPos_y, fToPos_z);

    cgGLSetParameter3f(param1, fToPos_x, fToPos_y, fToPos_z);
    cgGLSetParameter4f(param8, fVolumeWidth, fVolumeWidth, 0, 0.25f);// (SZx1, SZx2, TexX, TexY)
    cgGLSetParameter3f(param9, fVolumeWidth, 0, fHalfVolumeWidth);             // SZy
    cgGLSetParameter3f(param0, fFromPos_x, fFromPos_y, fFromPos_z);

	return;
}


// f`悷钼OɌĂяoVF[_֌W̏
void fk_VolumeLineModel::preShader(void)
{
	// vt@CLɂāAȍ~̕`ɃVF[_̏𔽉fĂ
	cgGLEnableProfile(vp_profile);
	cgGLEnableProfile(fp_profile);
	cgGLBindProgram(vertex_shader);
	cgGLBindProgram(fragment_shader);

	// p[^VF[_ɓn
	// sxNgAꂼɐp̖߂pӂĂ

	// Wϊn̍s͒萔nƂɑΉs񂪃Zbg
	cgGLSetStateMatrixParameter(model_view_proj_matrix,
			CG_GL_MODELVIEW_PROJECTION_MATRIX,
			CG_GL_MATRIX_IDENTITY);
	cgGLSetStateMatrixParameter(model_view_matrix,
			CG_GL_MODELVIEW_MATRIX,
			CG_GL_MATRIX_IDENTITY);

	// eNX`RlNg
	cgGLEnableTextureParameter(f_tex[0]);
	cgGLEnableTextureParameter(f_tex[1]);
	cgGLSetTextureParameter(f_tex[0], tex[0]);
	cgGLSetTextureParameter(f_tex[1], tex[1]);

	// preShader()ŕ`悵Ă܂\ɏo܂
	{
		glBlendFunc(GL_ONE, GL_ONE);
		glDepthMask(GL_FALSE);

		glBegin(GL_QUADS);
		for(int i = 0; i < (int)lenArray.size(); i++) {
			draw_line(posArray[i*2], posArray[i*2+1], (float)lenArray[i]);
		}
		glEnd();

		glDepthMask(GL_TRUE);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

	return;
}
// f`̏
void fk_VolumeLineModel::postShader(void)
{
	// vt@C𖳌ɂāAVF[_𔽉f`I
	cgGLDisableTextureParameter(f_tex[1]);
	cgGLDisableTextureParameter(f_tex[0]);
	cgGLDisableProfile(vp_profile);
	cgGLDisableProfile(fp_profile);

	return;
}

void fk_VolumeLineModel::setImage(fk_Image *argImage)
{
	ref_image = argImage;
	if(ref_image == NULL) return;

	const fk_ImType		*imageBuf = argImage->getBufPointer();
	const fk_Dimension	*bufSize = argImage->getBufferSize();

	for(int i = 0; i < 2; i++) {
		glGenTextures(1, &tex[i]);
		glBindTexture(GL_TEXTURE_2D, tex[i]);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, bufSize->w, bufSize->h,
					0, GL_RGBA, GL_UNSIGNED_BYTE, imageBuf);
		glBindTexture(GL_TEXTURE_2D, 0);
	}

	return;
}

fk_Image * fk_VolumeLineModel::getImage(void)
{
	return ref_image;
}

void fk_VolumeLineModel::allClear(void)
{
	posArray.clear();
	lenArray.clear();

	return;
}

int fk_VolumeLineModel::pushLine(fk_Vector argA, fk_Vector argB, double argL)
{
	posArray.push_back(argA);
	posArray.push_back(argB);
	lenArray.push_back(argL);

	return (int)lenArray.size()-1;
}

bool fk_VolumeLineModel::changeLine(int argID, fk_Vector argA, fk_Vector argB, double argL)
{
	if(argID < 0 || argID >= (int)lenArray.size()) return false;

	posArray[argID*2]	= argA;
	posArray[argID*2+1] = argB;
	lenArray[argID]		= argL;

	return true;
}

int fk_VolumeLineModel::getLinesNum(void)
{
	return (int)lenArray.size();
}

bool fk_VolumeLineModel::getLineInfo(int argID, fk_Vector *argP_A, fk_Vector *argP_B, double *argP_L)
{
	if(argID < 0 || argID >= (int)lenArray.size()) return false;

	if(argP_A != NULL) *argP_A = posArray[argID*2];
	if(argP_B != NULL) *argP_B = posArray[argID*2+1];
	if(argP_L != NULL) *argP_L = lenArray[argID];

	return true;
}
